%script solves epidemic model using Eulers method
%PC - MA428
N= 3000; %initial population
H_0 = 3000-150; % (initial healhty = initial population - initally infected)
D_0 = 0; %initially nobody is dead.
m=1.8; % mortality rate
c=0.001;% transmision rate
h =0.1; %time step in weeks

%Using Eulers method for the time stepping starting at t=0;
approx_sol_D =[];
approx_sol_H =[];
approx_sol_I =[];
%initialize the solution vectors with initial conditions.
approx_sol_D(1) =0;
approx_sol_H(1) =H_0;
approx_sol_I(1) =150;
current_time =0;
i=2;
difference=2;
current_time_vector =[];
current_time_vector(1)= 0;

while(difference>0.1)
    approx_sol_D(i) =  approx_sol_D(i-1) + h*feval('infection_model',N,approx_sol_D(i-1),H_0,c,m);
    current_time = current_time+h;
    current_time_vector=[current_time_vector;current_time];
    H = H_0*exp((-c*approx_sol_D(i))/m);
    approx_sol_H(i) = H;
    I = 3000-H-approx_sol_D(i);
    difference = approx_sol_D(i)-approx_sol_D(i-1)
    approx_sol_I(i)= I;
    i=i+1; 
end
hold on %to enable plots to be on the same figure!
plot(current_time_vector,approx_sol_D');
plot(current_time_vector,approx_sol_H');
plot(current_time_vector,approx_sol_I');
legend('Healthy','Infected','Dead'); %these need to be in the same order as your plots
hold off
fprintf('Number of people dead at %d weeks is %d \n',round(current_time),round(approx_sol_D(length(approx_sol_D))));

    
    


